Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class frmUTM
	Inherits System.Windows.Forms.Form

	Dim K0, EKRADIUS, F, E0 As Double
	Dim COLN, FLAG As Short
	Dim DLIEXE As Integer
	Dim FIL1, FIL2, TEKPAP, WIRO(4000), DOLG(4000) As String
	Dim VOST(4000), SEVE(4000) As Double
	
	Const PI As Double = 3.14159265358979
	
	Private Function acos(ByRef X As Double) As Double
		acos = PI / 2 - Asin(X)
	End Function
	
	Private Function arch(ByRef X As Double) As Double
		Arch = System.Math.Log(X + System.Math.Sqrt(X * X - 1))
	End Function
	
	Private Function arsh(ByRef X As Double) As Double
		Arsh = System.Math.Log(X + System.Math.Sqrt(X * X + 1))
	End Function
	
	Private Function arth(ByRef X As Double) As Double
		Arth = System.Math.Log((1 + X) / (1 - X)) / 2
	End Function
	
	Private Function asin(ByRef X As Double) As Double
		Asin = System.Math.Atan(X / System.Math.Sqrt(1 - X * X))
	End Function

	Private Function sinh(ByRef X As Double) As Double
		sinh = (System.Math.Exp(X) - System.Math.Exp(-X)) / 2
	End Function

	Private Function tanh(ByRef X As Double) As Double
		tanh = (System.Math.Exp(X) - System.Math.Exp(-X)) / (System.Math.Exp(X) + System.Math.Exp(-X))
	End Function

	Private Function cosh(ByRef X As Double) As Double
		cosh = (System.Math.Exp(X) + System.Math.Exp(-X)) / 2
	End Function

	Private Sub frmUTM_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		TEKPAP = CurDir()
		FIL1 = ""
		EKRADIUS = 6378.137
		F = 1 / 298.257223563
		K0 = 0.9996
		E0 = 500
	End Sub

	Private Sub frmUTM_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		End
	End Sub

	Private Sub cbAUTO_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbAUTO.Click
		Dim S, R As String
		Dim T As Double
		COLN = 0
		FileOpen(1, FIL1, OpenMode.Input)
		While Not EOF(1) And COLN < 4000
			S = LineInput(1) : S = Trim(S)
			T = InStr(1, S, " ")
			If T = 0 Then
				T = InStr(1, S, Chr(9))
				If T = 0 Then MsgBox("Error in file format") : COLN = 0 : Exit Sub
			End If
			COLN = COLN + 1
			R = VB.Left(S, T - 1) : WIRO(COLN) = Trim(R)
			R = Mid(S, T + 1) : DOLG(COLN) = Trim(R)
		End While
		FileClose(1)
		CIKLUTM()
	End Sub
	
	Private Sub cbCLIP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbCLIP.Click
		Dim Q2, Q1, I As Double
		Dim P, WIR, S1, S2, DOL, V As String
		S1 = txtLATI.Text
		If S1 = "" Then MsgBox("Latitude not found") : Exit Sub
		S2 = txtLONG.Text
		If S2 = "" Then MsgBox("Longitude not found") : Exit Sub
		COLN = 0 : P = Chr(13) & Chr(10)
		Do 
			Q1 = InStr(1, S1, P) : Q2 = InStr(1, S2, P)
			If Q1 = 0 Or Q2 = 0 Then Exit Do
			COLN = COLN + 1
			WIR = VB.Left(S1, Q1 - 1) : S1 = Mid(S1, Q1 + 2) : WIRO(COLN) = WIR
			DOL = VB.Left(S2, Q2 - 1) : S2 = Mid(S2, Q2 + 2) : DOLG(COLN) = DOL
		Loop While S1 <> "" And S2 <> "" And COLN < 4000
		If COLN = 0 Then MsgBox("Error in source data") : Exit Sub
		CIKLUTM()
		If FLAG Then Exit Sub
		S1 = "" : S2 = ""
		For I = 1 To COLN
			S1 = S1 & LTrim(Str(Fix(VOST(I) * 1000) / 1000)) & P
			S2 = S2 & LTrim(Str(Fix(SEVE(I) * 1000) / 1000)) & P
		Next I
		txtEAST.Text = S1 : txtNORT.Text = S2
	End Sub
	
	Private Sub cbMANU_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbMANU.Click
		Dim EE, FI, LAMBDA, NN As Double
		FI = Val(txtWIRDEC.Text)
		LAMBDA = Val(txtDOLDEC.Text)
		If optS.Checked Then FI = -FI
		If optW.Checked Then LAMBDA = -LAMBDA
		RASHETUTM(FI, LAMBDA, EE, NN)
		txtUTMX.Text = Str(EE) : txtUTMY.Text = Str(NN)
	End Sub
	
	Private Sub cbOPEN_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbOPEN.Click
		diaOPEN.InitialDirectory = TEKPAP
		diaOPEN.Filter = "(*.txt)|*.txt"
		diaOPEN.FilterIndex = 1
		diaOPEN.RestoreDirectory = False
		If (diaOPEN.ShowDialog() = Windows.Forms.DialogResult.OK) Then
			FIL1 = diaOPEN.FileName
			TEKPAP = My.Computer.FileSystem.GetParentPath(FIL1)
		End If
		lblFILE1.Text = FIL1
	End Sub
	
	Private Sub cbSAVE_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cbSAVE.Click
		Dim I As Short
		FIL2 = FIL1 : If FIL2 = "" Then Exit Sub
		diaSAVE.InitialDirectory = TEKPAP
		diaSAVE.Filter = "(*.txt)|*.txt|(*.*)|*.*"
		diaSAVE.FilterIndex = 1
		diaSAVE.RestoreDirectory = False
		If (diaSAVE.ShowDialog() = Windows.Forms.DialogResult.OK) Then
			FIL2 = diaSAVE.FileName
			TEKPAP = My.Computer.FileSystem.GetParentPath(FIL2)
		End If
		lblFILE2.Text = FIL2
		FileOpen(2, FIL2, OpenMode.Output)
		For I = 1 To COLN
			PrintLine(2, VOST(I), SEVE(I))
		Next I
		FileClose(2)
	End Sub

	Public Sub mnuABOUT_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuABOUT.Click
		frmABOUT.ShowDialog()
	End Sub
	
	Public Sub mnuAUTO_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuAUTO.Click
		frAUTO.Visible = True
		frCLIP.Visible = False
		frMANU.Visible = False
		mnuAUTO.Checked = True
		mnuCLIP.Checked = False
		mnuMANU.Checked = False
	End Sub
	
	Public Sub mnuCLIP_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuCLIP.Click
		frAUTO.Visible = False
		frCLIP.Visible = True
		frMANU.Visible = False
		mnuAUTO.Checked = False
		mnuCLIP.Checked = True
		mnuMANU.Checked = False
	End Sub
	
	Public Sub mnuEXIT_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuEXIT.Click
		Me.Close()
	End Sub
	
	Public Sub mnuMANU_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuMANU.Click
		frAUTO.Visible = False
		frCLIP.Visible = False
		frMANU.Visible = True
		mnuAUTO.Checked = False
		mnuCLIP.Checked = False
		mnuMANU.Checked = True
	End Sub

	Public Sub mnuWORK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuWORK.Click
		frmHELP.ShowDialog()
	End Sub
	
	Private Sub txtDOLDEC_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtDOLDEC.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		Dim MINA, VREM, GRAD, SEKA As Double
		VREM = Val(txtDOLDEC.Text)
		DECDOLI(VREM, GRAD, MINA, SEKA)
		txtDOLGRAD.Text = Str(GRAD)
		txtDOLMIN.Text = Str(MINA)
		txtDOLSEK.Text = Str(SEKA)
	End Sub
	
	Private Sub txtDOLGRAD_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtDOLGRAD.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtDOLDEC.Text = Str(Val(txtDOLGRAD.Text) + Val(txtDOLMIN.Text) / 60 + Val(txtDOLSEK.Text) / 3600)
	End Sub
	
	Private Sub txtDOLMIN_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtDOLMIN.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtDOLDEC.Text = Str(Val(txtDOLGRAD.Text) + Val(txtDOLMIN.Text) / 60 + Val(txtDOLSEK.Text) / 3600)
	End Sub
	
	Private Sub txtDOLSEK_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtDOLSEK.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtDOLDEC.Text = Str(Val(txtDOLGRAD.Text) + Val(txtDOLMIN.Text) / 60 + Val(txtDOLSEK.Text) / 3600)
	End Sub
	
	Private Sub txtWIRDEC_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtWIRDEC.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		Dim MINA, VREM, GRAD, SEKA As Double
		VREM = Val(txtWIRDEC.Text)
		DECDOLI(VREM, GRAD, MINA, SEKA)
		txtWIRGRAD.Text = Str(GRAD)
		txtWIRMIN.Text = Str(MINA)
		txtWIRSEK.Text = Str(SEKA)
	End Sub
	
	Private Sub txtWIRGRAD_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtWIRGRAD.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtWIRDEC.Text = Str(Val(txtWIRGRAD.Text) + Val(txtWIRMIN.Text) / 60 + Val(txtWIRSEK.Text) / 3600)
	End Sub
	
	Private Sub txtWIRMIN_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtWIRMIN.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtWIRDEC.Text = Str(Val(txtWIRGRAD.Text) + Val(txtWIRMIN.Text) / 60 + Val(txtWIRSEK.Text) / 3600)
	End Sub
	
	Private Sub txtWIRSEK_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles txtWIRSEK.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		txtWIRDEC.Text = Str(Val(txtWIRGRAD.Text) + Val(txtWIRMIN.Text) / 60 + Val(txtWIRSEK.Text) / 3600)
	End Sub

	Private Sub RASHETUTM(ByRef FI As Double, ByRef LAMBDA As Double, ByRef EE As Double, ByRef NN As Double)
		Dim N, T, N0, ZONA, L0, A, J As Double
		Dim SIGMA, DZETA1, ETA1, TAU As Double
		Static ALFA(3) As Double
		Static BETA(3) As Double
		Static DELTA(3) As Double

		ZONA = Int((LAMBDA + 180) / 6) + 1
		L0 = (ZONA * 6 - 183) / 180 * PI
		If FI >= 0 Then N0 = 0 Else N0 = 10000
		FI = FI / 180 * PI
		LAMBDA = LAMBDA / 180 * PI

		N = F / (2 - F)
		A = EKRADIUS / (1 + N) * (1 + N * N / 4 + N ^ 4 / 64)

		ALFA(1) = 1 / 2 * N - 2 / 3 * N ^ 2 + 5 / 16 * N ^ 3
		ALFA(2) = 13 / 48 * N ^ 2 - 3 / 5 * N ^ 3
		ALFA(3) = 61 / 240 * N ^ 3
		BETA(1) = 1 / 2 * N - 2 / 3 * N ^ 2 + 37 / 96 * N ^ 3
		BETA(2) = 1 / 48 * N ^ 2 + 1 / 15 * N ^ 3
		BETA(3) = 17 / 480 * N ^ 3
		DELTA(1) = 2 * N - 2 / 3 * N ^ 2 - 2 * N ^ 3
		DELTA(2) = 7 / 3 * N ^ 2 - 8 / 5 * N ^ 3
		DELTA(3) = 56 / 15 * N ^ 3

		T = sinh(Arth(System.Math.Sin(FI)) - 2 * System.Math.Sqrt(N) / (1 + N) * Arth(2 * System.Math.Sqrt(N) / (1 + N) * System.Math.Sin(FI)))

		DZETA1 = System.Math.Atan(T / System.Math.Cos(LAMBDA - L0))
		ETA1 = Arth(System.Math.Sin(LAMBDA - L0) / System.Math.Sqrt(1 + T ^ 2))
		SIGMA = 1 : TAU = 0
		For J = 1 To 3
			SIGMA = SIGMA + 2 * J * ALFA(J) * System.Math.Cos(2 * J * DZETA1) * cosh(2 * J * ETA1)
			TAU = TAU + 2 * J * ALFA(J) * System.Math.Sin(2 * J * DZETA1) * sinh(2 * J * ETA1)
		Next J

		EE = ETA1 : NN = DZETA1
		For J = 1 To 3
			EE = EE + ALFA(J) * System.Math.Cos(2 * J * DZETA1) * sinh(2 * J * ETA1)
			NN = NN + ALFA(J) * System.Math.Sin(2 * J * DZETA1) * cosh(2 * J * ETA1)
		Next J
		EE = (E0 + K0 * A * EE) * 1000
		NN = (N0 + K0 * A * NN) * 1000

	End Sub

	Private Sub RAZBOR(ByRef P As String, ByRef UGOL As Double)
		Dim GRAD As Double
		Dim Q, QQ As Integer
		UGOL = -360
		Q = InStr(1, P, "") : If Q = 0 Then Exit Sub
		GRAD = Val(VB.Left(P, Q - 1))
		QQ = InStr(Q + 1, P, "'") : If QQ = 0 Then Exit Sub
		GRAD = GRAD + System.Math.Sign(GRAD) * Val(Mid(P, Q + 1, QQ - Q - 1)) / 60
		Q = InStr(QQ + 1, P, Chr(34))
		If Q = 0 Then
			Q = InStr(QQ + 1, P, "''") : If Q = 0 Then Exit Sub
		End If
		GRAD = GRAD + System.Math.Sign(GRAD) * Val(Mid(P, QQ + 1, Q - QQ - 1)) / 3600
		UGOL = GRAD
	End Sub

	Private Sub CIKLUTM()
		Dim EE, FI, I, LAMBDA, NN As Double
		Dim V As String
		FLAG = 0
		For I = 1 To COLN
			V = WIRO(I) : RAZBOR(V, FI)
			If FI = -360 Then MsgBox("Error in latitude, line" & Str(I)) : FLAG = -1 : Exit Sub
			V = DOLG(I) : RAZBOR(V, LAMBDA)
			If LAMBDA = -360 Then MsgBox("Error in longitude, line" & Str(I)) : FLAG = -1 : Exit Sub
			RASHETUTM(FI, LAMBDA, EE, NN)
			VOST(I) = EE : SEVE(I) = NN
		Next I
	End Sub

	Private Sub DECDOLI(ByRef VREM As Double, ByRef GRAD As Double, ByRef MINA As Double, ByRef SEKA As Double)
		GRAD = Fix(VREM)
		SEKA = (VREM - GRAD) * 60
		MINA = Fix(SEKA)
		SEKA = (SEKA - MINA) * 60
	End Sub

End Class